unit UXDBTable;

//**********************************************************
//W : TXDBTable For AspFileDB Suit
//s@ : 2003/12/20
//s@ʾ : αAspFileDB Suit To Standard VCL DB Controls
//gH(@) :Ying-Cheng Lin
//     : Beta 1.0
//SOn : Only Share To Delphi KTop Members !!
//           Фnoǻr,Kis!!
//---------------------HUק-----------------------
//קH :
//ק] :
//ק :
//s :
//**********************************************************

interface

uses
  SysUtils, Classes, DB,DBTables,Forms,Dialogs,UAspFileDataset,
  DesignIntf,DesignEditors;

type

  //*********FKMTDataSetOX@,ҥHwqXHUƵc***********
  TVCLMemDataPage = string[255];
  PTXDBBookMarkInfo = ^TXDBBookMarkInfo;
  TXDBBookMarkInfo = record
    BookMarkData:integer;
    BookMarkFlag:TBookMarkFlag;
  end;
  PTXDBNode = ^TXDBNode;
  TXDBNode = record
    MetaData    :array[1..13] of TVCLMemDataPage;
  end;
  //************************************************************************
  TXDBFileStr  = type String;
  TXDBFileName = class(TStringProperty)
  public
    procedure Edit; override;
    function  GetAttributes: TPropertyAttributes; override;
  end;
  //HUOڭ̪D
  TXDBTable = class(TDataSet)
  private
    RealXDBDataSize:integer;//ϥܼ
    //----------------------
    FCacheUpdate   :boolean;
    FReadOnly      :boolean;
    FData          :TAspFileDataSet;
    FRecSize       :Integer;
    FRecBufSize    :Integer;
    FCurRec        :Integer;
    FFileName      :TXDBFileStr;
    FUserName      :string; 
    FLastBookmark  :LongInt;
    FSaveChanges   :Boolean;
    procedure SetFReadOnly(const Value: boolean);
    procedure SetFCacheUpdate(const Value: boolean);
  protected
    //DataSnap ( MIDAS ) Support !!
    function  PSUpdateRecord(UpdateKind: TUpdateKind; Delta: TDataSet): Boolean; override;
  protected
    function  AllocRecordBuffer: PChar; override;
    procedure FreeRecordBuffer(var Buffer: PChar); override;
    procedure GetBookmarkData(Buffer: PChar; Data: Pointer); override;
    function  GetBookmarkFlag(Buffer: PChar): TBookmarkFlag; override;
    function  GetFieldData(Field: TField; Buffer: Pointer): Boolean; override;
    function  GetRecordCount: Integer; override;
    function  GetRecord(Buffer: PChar; GetMode: TGetMode; DoCheck: Boolean): TGetResult; override;
    function  GetRecordSize: Word; override;
    function  GetCanModify: Boolean; override;
    procedure InternalAddRecord(Buffer: Pointer; Append: Boolean); override;
    procedure InternalClose; override;
    procedure InternalDelete; override;
    procedure InternalFirst; override;
    procedure InternalGotoBookmark(Bookmark: Pointer); override;
    procedure InternalHandleException; override;
    procedure InternalInitFieldDefs; override;
    procedure InternalInitRecord(Buffer: PChar); override;
    procedure InternalLast; override;
    procedure InternalOpen; override;
    procedure InternalPost; override;
    procedure InternalSetToRecord(Buffer: PChar); override;
    function  IsCursorOpen: Boolean; override;
    procedure SetBookmarkFlag(Buffer: PChar; Value: TBookmarkFlag); override;
    procedure SetBookmarkData(Buffer: PChar; Data: Pointer); override;
    procedure SetFieldData(Field: TField; Buffer: Pointer); override;
    function  GetRecNo: Integer; override;
    procedure SetRecNo(Value: Integer); override;
  public
    Constructor Create(AOwner: TComponent); override;
    Destructor  Destroy; override;
    function    FindKey(const KeyValues: array of const): Boolean;
    procedure   ApplyUpdates; 
  published
    property CacheUpdate:boolean read FCacheUpdate write SetFCacheUpdate;
    property FileName :TXDBFileStr read FFileName write FFileName;
    property UserName:string read FUserName write FUserName;
    property DataSetField;

    property ReadOnly:boolean read FReadOnly write SetFReadOnly;

    property FieldDefs;
    property Filter;
    property Filtered;
    property Active;
    property BeforeOpen;
    property AfterOpen;
    property BeforeClose;
    property AfterClose;
    property BeforeInsert;
    property AfterInsert;
    property BeforeEdit;
    property AfterEdit;
    property BeforePost;
    property AfterPost;
    property BeforeCancel;
    property AfterCancel;
    property BeforeDelete;
    property AfterDelete;
    property BeforeScroll;
    property AfterScroll;
    property OnCalcFields;
    property OnDeleteError;
    property OnEditError;
    property OnNewRecord;
    property OnPostError;
  end;


procedure Register;

implementation

procedure Register;
begin
  RegisterPropertyEditor( TypeInfo(TXDBFileStr),nil,'',TXDBFileName);
  RegisterComponents('AspFileDBSuit', [TXDBTable]);
end;

//*********FKMTDataSetOX@,ҥHwqXHUƵcBz禡***********
function GetPageStrInString(EachPageSize,PageNo:integer;inStr:string):string;
var StartCharNo,EndCharNo,i:integer;
    inStrSize:integer;
    rStr:string;
begin
  result := ''; rStr := '';
  if(inStr = '')then Exit;
  if(PageNo = 0)then Exit;
  StartCharNo := EachPageSize*(PageNo-1)+1;
  EndCharNo   := StartCharNo+EachPageSize-1;
  inStrSize   := Length(inStr);
  for i := StartCharNo to EndCharNo do
    if(i <= inStrSize)then rStr := rStr+instr[i]
    else Break;
  Result := rStr;
end;

procedure PutDataStrToPageArray(var dataPage:TXDBNode;inStr: string);
var strSize:integer;
    haveData:boolean;
    function DataToPage(pgno:integer):boolean;
    begin
      result := FALSE;
      dataPage.MetaData[pgno]
       := GetPageStrInString(255,pgno,inStr);
      if(Length(dataPage.MetaData[pgno]) > 0)then result := TRUE;
    end;
begin
  dataPage.MetaData[ 1] := '';
  dataPage.MetaData[ 2] := '';
  dataPage.MetaData[ 3] := '';
  dataPage.MetaData[ 4] := '';
  dataPage.MetaData[ 5] := '';
  dataPage.MetaData[ 6] := '';
  dataPage.MetaData[ 7] := '';
  dataPage.MetaData[ 8] := '';
  dataPage.MetaData[ 9] := '';
  dataPage.MetaData[10] := '';
  dataPage.MetaData[11] := '';
  dataPage.MetaData[12] := '';
  dataPage.MetaData[13] := '';
  strSize := Length(inStr);
  if(strSize <= 255)then dataPage.MetaData[1] := inStr
  else
    begin
      haveData := DataToPage(1);
      if(haveData = TRUE)then haveData := DataToPage( 2);
      if(haveData = TRUE)then haveData := DataToPage( 3);
      if(haveData = TRUE)then haveData := DataToPage( 4);
      if(haveData = TRUE)then haveData := DataToPage( 5);
      if(haveData = TRUE)then haveData := DataToPage( 6);
      if(haveData = TRUE)then haveData := DataToPage( 7);
      if(haveData = TRUE)then haveData := DataToPage( 8);
      if(haveData = TRUE)then haveData := DataToPage( 9);
      if(haveData = TRUE)then haveData := DataToPage(10);
      if(haveData = TRUE)then haveData := DataToPage(11);
      if(haveData = TRUE)then haveData := DataToPage(12);
      if(haveData = TRUE)then haveData := DataToPage(13);
    end;//else...end!!
end;
//****************************************************************************

Constructor TXDBTable.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FData := TAspFileDataset.Create(nil);
  FData.AccessFile := self.FFileName;
  FData.AccessUser := self.UserName;
  FRecSize    := SizeOf(TXDBNode);
  FRecBufSize := FRecSize+SizeOf(TXDBBookMarkInfo);
end;

Destructor TXDBTable.Destroy;
begin
  if(FData <> nil)then
    begin
      FData.Active     := FALSE;
      FData.AccessFile := '';
      FData.Free;
      FData := nil;
    end;//if...end!!
  inherited Destroy;
end;

procedure TXDBTable.InternalOpen;
var i,StrStartID,ds:integer;
    ft:TField;
    fn:string;
begin
  if(FData = nil)then Exit;
  FData.Active := FALSE;
  FData.AccessUser := self.FUserName;
  FData.AccessFile := Self.FFileName;
  FData.Active := TRUE;
  if(FData.FieldCount > 0)then
    begin
      // Initializing field definitions and field creation (TFields)
      InternalInitFieldDefs;
      if(DefaultFields)then CreateFields;
      BindFields(True);
      //---------------------------------
      StrStartID := 1;
      for i := 0 to self.FieldCount-1 do
        begin
          ft := self.Fields[i];
          if(i = 0)then
            begin
              ft.Tag := 1;
            end//if...end!!
          else
            begin
              fn := self.Fields[i-1].FieldName;
              ds := FData.FieldDataSize(fn);
              StrStartID := StrStartID+ds;
              ft.Tag := StrStartID;
            end;
          ft := nil;  
        end;//for...i...end!!
    end;//if...end!!
  FCurRec := 0;
end;

procedure TXDBTable.InternalClose;
begin
  if(DefaultFields)then DestroyFields;
  if(fData <> nil)then
    begin
      fData.Active  := FALSE;
      fData.AccessFile     := '';
      fData.SchemaFileName := '';
    end;//if...end!!  
  FlastBookMark := 0;
  FCurRec       := -1;
end;

function TXDBTable.IsCursorOpen: Boolean;
begin
  if(FData = nil)then Exit;
  Result := Assigned(FData)and(FData.FieldCount > 0);
end;

procedure TXDBTable.InternalInitFieldDefs;
var i,ds:integer;
    str:string;
begin
  if(FData = nil)then Exit;
  self.RealXDBDataSize := 0;
  FieldDefs.Clear;
  for i := 0 to FData.FieldCount-1 do
    begin
      str := FData.FieldName(i);
      ds  := FData.FieldDataSize(str);
      TFieldDef.Create( FieldDefs
                       ,str
                       ,ftString
                       ,ds
                       ,FData.IsKeyField(str)
                       ,i);
      self.RealXDBDataSize := self.RealXDBDataSize+ds;
    end;//for...i..end!!
end;

procedure TXDBTable.InternalHandleException;
begin
  Application.HandleException(Self);
end;

//BookMarks.
procedure TXDBTable.InternalGotoBookmark(Bookmark: Pointer);
var Index:Integer;
begin
  Index := Integer(Bookmark^);
  if(Index <> -1)then FCurRec := Index;
end;

procedure TXDBTable.InternalSetToRecord(Buffer: PChar);
begin
  InternalGotoBookmark(@PTXDBBookMarkInfo(Buffer + Self.FRecSize)^.BookmarkData);
end;

function TXDBTable.GetBookmarkFlag(Buffer: PChar): TBookmarkFlag;
begin
  Result := PTXDBBookMarkInfo(Buffer + self.FRecSize)^.BookMarkFlag;
end;

procedure TXDBTable.SetBookmarkFlag(Buffer: PChar; Value: TBookmarkFlag);
begin
  PTXDBBookMarkInfo(Buffer + self.FRecSize)^.BookmarkFlag := Value;
end;

procedure TXDBTable.GetBookmarkData(Buffer: PChar; Data: Pointer);
begin
  Integer(Data) := PTXDBBookMarkInfo(Buffer + self.FRecSize)^.BookMarkData;
end;

procedure TXDBTable.SetBookmarkData(Buffer: PChar; Data: Pointer);
begin
  PTXDBBookMarkInfo(Buffer + self.FRecSize)^.BookMarkData := Integer(Data);
end;

function TXDBTable.GetRecordSize: Word;
begin
  Result := FRecSize;
end;

function TXDBTable.AllocRecordBuffer: PChar;
begin
  //tmC@recordһݪBufferjp
  GetMem(Result, FRecBufSize);
end;

procedure TXDBTable.FreeRecordBuffer(var Buffer: PChar);
begin
  FreeMem(Buffer, FRecBufSize);
end;

function TXDBTable.GetRecord(Buffer: PChar; GetMode: TGetMode;
                    DoCheck: Boolean): TGetResult;
var fstr,str,DataStr:string;
    i,dataLength,fdofs:integer;
begin
  if(FData = nil)then Exit;
  if(RecordCount < 1)then Result := grEOF
  else
    begin
      DataStr := '';
      fdofs := 1;
      for i := 0 to FData.FieldCount-1 do
        begin
          str  := '';
          fstr := self.FData.FieldName(i);
          dataLength := self.FData.FieldDataSize(fstr);
          str := str+self.FData.FieldByName(fstr).AsString;
          while(Length(str) < dataLength)do
            str := str+' ';
          DataStr := DataStr+str;
        end;//for...i...end!!
      PTXDBNode(Buffer)^.MetaData[ 1] := '';
      PTXDBNode(Buffer)^.MetaData[ 2] := '';
      PTXDBNode(Buffer)^.MetaData[ 3] := '';
      PTXDBNode(Buffer)^.MetaData[ 4] := '';
      PTXDBNode(Buffer)^.MetaData[ 5] := '';
      PTXDBNode(Buffer)^.MetaData[ 6] := '';
      PTXDBNode(Buffer)^.MetaData[ 7] := '';
      PTXDBNode(Buffer)^.MetaData[ 8] := '';
      PTXDBNode(Buffer)^.MetaData[ 9] := '';
      PTXDBNode(Buffer)^.MetaData[10] := '';
      PTXDBNode(Buffer)^.MetaData[11] := '';
      PTXDBNode(Buffer)^.MetaData[12] := '';
      PTXDBNode(Buffer)^.MetaData[13] := '';
      PutDataStrToPageArray(PTXDBNode(Buffer)^,DataStr);
      //-----------------------------------------------------------------
      PTXDBBookMarkInfo(Buffer+Self.FRecSize)^.BookMarkData := FCurRec;
      PTXDBBookMarkInfo(Buffer+Self.FRecSize)^.BookMarkFlag := bfCurrent;

      case GetMode of
        gmPrior:   if(FCurRec <= 0)then Result := grBOF
                   else
                     begin
                       if(self.FData.IsBof = TRUE)then
                         Result := grBOF;
                       self.FData.Prior;
                       Dec(FCurRec);
                     end;

        gmCurrent: if(FCurRec < 0)or(FCurRec >= RecordCount)then
                      Result := grError;

        gmNext:    if(FCurRec >= RecordCount)then Result := grEOF
                   else
                     begin
                       if(self.FData.IsEof = TRUE)then
                         Result := grEOF;
                       self.FData.Next;
                       Inc(FCurRec);
                     end;
      end;//case...end!!
    end;//else...end!!
end;

procedure TXDBTable.InternalInitRecord(Buffer: PChar);
begin
  PTXDBNode(Buffer)^.MetaData[ 1] := '';
  PTXDBNode(Buffer)^.MetaData[ 2] := '';
  PTXDBNode(Buffer)^.MetaData[ 3] := '';
  PTXDBNode(Buffer)^.MetaData[ 4] := '';
  PTXDBNode(Buffer)^.MetaData[ 5] := '';
  PTXDBNode(Buffer)^.MetaData[ 6] := '';
  PTXDBNode(Buffer)^.MetaData[ 7] := '';
  PTXDBNode(Buffer)^.MetaData[ 8] := '';
  PTXDBNode(Buffer)^.MetaData[ 9] := '';
  PTXDBNode(Buffer)^.MetaData[10] := '';
  PTXDBNode(Buffer)^.MetaData[11] := '';
  PTXDBNode(Buffer)^.MetaData[12] := '';
  PTXDBNode(Buffer)^.MetaData[13] := '';
end;

function TXDBTable.GetFieldData(Field: TField; Buffer: Pointer): Boolean;
var i,StartID,EndID,ds:integer;
    fn,DataStr,str:string;
begin
  DataStr := '';
  str := '';
  fn  := Field.FieldName;
  ds  := Field.DataSize-1;
  for i := 1 to 13 do
    if(PTXDBNODE(ActiveBuffer)^.MetaData[i] <> '')then
      DataStr := DataStr + PTXDBNODE(ActiveBuffer)^.MetaData[i];
  //------------------------------------------------------------
  if(trim(DataStr) <> '')then
  if(Length(DataStr) >= Field.Tag+ds-1)then
    begin
      StartID := Field.Tag;
      EndID   := Field.Tag+ds-1;
      for i := StartID to EndID do str := str+DataStr[i];
      //------------------------------------------------------------
      StrLCopy(Buffer,PChar(str), Field.DataSize);
      Result := PChar(Buffer)^ <> #0;
    end//if...end!!
  else Result := FALSE;
end;

procedure TXDBTable.SetFieldData(Field: TField; Buffer: Pointer);
var i,j,id,StartID,EndID:integer;
    DataStr,tmpDataStr,tmpStr:string;
begin
  tmpDataStr := ''; DataStr := '';
  for i := 1 to 13 do
    if(PTXDBNODE(ActiveBuffer)^.MetaData[i] <> '')then
      tmpDataStr := DataStr+PTXDBNODE(ActiveBuffer)^.MetaData[i];
  DataStr := tmpDataStr;
  tmpStr  := PChar(Buffer);
  //-----------------------------------------
  while(Length(tmpStr) < Field.DataSize-1)do
    tmpStr := tmpStr + ' ';
  //-----------------------------------------
  if(trim(DataStr) = '')then
    DataStr := DataStr+tmpStr
  else
    begin
      if(Length(DataStr) >= (Field.Tag+Field.DataSize-1))then
        begin//ƿJP@Field
          id := 1;
          StartID := Field.Tag;
          EndID   := Field.Tag+Field.DataSize-1;
          for j := StartID to EndID do
            if(tmpStr[id] <> #0)then
              begin
                DataStr[j] := tmpStr[id];
                id := id+1;
              end;//for...j...end!!
        end//if...end!!
      else DataStr := DataStr+tmpStr;
    end;
  PutDataStrToPageArray(PTXDBNODE(ActiveBuffer)^,DataStr);
  DataEvent(deFieldChange, Longint(Field));
end;

procedure TXDBTable.InternalFirst;
begin
  if(FData = nil)then Exit;
  FCurRec := -1;
  self.FData.First;
end;

procedure TXDBTable.InternalLast;
begin
  if(FData = nil)then Exit;
  FCurRec := RecordCount;
  self.FData.Last;
end;

procedure TXDBTable.InternalPost;
var i:integer;
    fdStr,DataStr:string; 
begin
  if(FData = nil)then Exit;
  Inc(FLastBookmark);
  self.FData.Insert;
  //------------------------------------------------------
  for i := 0 to self.FieldCount-1 do
    begin
      fdStr   := self.Fields[i].FieldName;
      DataStr := self.Fields[i].AsString;
      self.FData.FieldByName(fdStr).AsString := DataStr;
    end;//for...i...end!!
  self.FData.Post;
end;

procedure TXDBTable.InternalAddRecord(Buffer: Pointer; Append: Boolean);
var i,j,StartId,EndID:integer;
    DataStr,tmpStr:string;
begin
  if(FData = nil)then Exit;
  Inc(FLastBookmark);
  //Keep !! if(Append = TRUE)then InternalLast;
  self.FData.Insert;
  for i := 1 to 13 do
    if(PTXDBNode(Buffer)^.MetaData[i] <> '')then
      DataStr := DataStr + PTXDBNode(Buffer)^.MetaData[i];
  //------------------------------------------------------
  for i := 0 to self.FieldCount-1 do
    begin
      StartID := self.Fields[i].Tag;
      EndID   := self.Fields[i].Tag+self.Fields[i].DataSize-1;
      tmpStr := '';
      for j := startID to EndID do
        tmpStr := tmpStr+DataStr[j];
      self.FData.FieldByName(self.Fields[i].FieldName).AsString := tmpStr;
    end;//for...i...end!!
  self.FData.Post;
end;

procedure TXDBTable.InternalDelete;
begin
  if(FData = nil)then Exit;
  FData.GotoBookMark(FCurRec);
  FData.Delete;
  if(FCurRec >= FData.RecordCount)then Dec(FCurRec);
end;

function TXDBTable.GetRecNo: Longint;
begin
  if(FData = nil)then Exit;
  UpdateCursorPos;
  if(FCurRec = -1)and(fData.RecordCount > 0)then
    Result := 1
  else Result := FCurRec + 1;
end;

procedure TXDBTable.SetRecNo(Value: Integer);
begin
  if(FData = nil)then Exit;
  if(Value >= 0)and(Value < FData.RecordCount-1)then
    begin
      FCurRec := Value - 1;
      Resync([]);
    end;
end;

function TXDBTable.FindKey(const KeyValues: array of const): Boolean;
var i,j,ct : integer;
    Params:array[1..30] of string;
begin
  if(FData = nil)then Exit;
  Result := false;
  //ct := High(KeyValues);
  //debug !! ShowMessage(IntToStr(ct));
  //for i := 0 to FData.RowCount-1 do
   //if(ct = 0)then
  //   begin
   //    if(FData[0,i] = KeyValues[0].VPChar)then
  //       begin
   //        Result := true;
   //        FCurRec := i;
  //         Resync([]);
   //        Break;
  //       end;//if...end!!
  //   end//if...end!!
  // else
  //   begin
  //     for j := 0 to FData.ColCount-1 do
  //       begin
   //
  //       end;//for...j...end!!
  //   end;//if...else...end!!
end;

function TXDBTable.GetRecordCount: Integer;
begin
  if(FData = nil)then Exit;
  Result := FData.RecordCount;
end;

procedure TXDBTable.ApplyUpdates;
//var i:integer;
begin
  //FData.InsertRow(0, '', Pointer(0));
//  for i := 1 to FFldNames.Count do
//    Fdata[i-1,0] := FFldNames[i-1];
//  //------------------------------------
//  if(self.FCacheUpdate = TRUE)then
//    self.FData.SaveToFile(FileName);
end;

function TXDBTable.GetCanModify: Boolean;
begin
  if(FData = nil)then Exit;
  result := not self.FReadOnly;
end;

procedure TXDBTable.SetFReadOnly(const Value: boolean);
begin
  FReadOnly := Value;
end;

procedure TXDBTable.SetFCacheUpdate(const Value: boolean);
begin
  FCacheUpdate := Value;
end;

//======================================================================
//DataSnap ( MIDAS ) Support !!
function TXDBTable.PSUpdateRecord(UpdateKind: TUpdateKind;
  Delta: TDataSet): Boolean;

var i,j,recNo:integer;
    fname:string;
    keyStr,dataStr:string;
begin
  result := FALSE;
  Delta.First;
  case UpdateKind of
    ukInsert
      :begin
         for i := 0 to Delta.RecordCount-1 do
           begin
             self.Insert;
             for j := 0 to Delta.FieldCount-1 do
               begin
                 fname   := Delta.Fields[j].FieldName;
                 dataStr := Delta.FieldByName(fname).AsString;
                 //debug !! ShowMessage( 'Field : '+fname
                 //debug !!             +#10#13
                 //debug !!             +'Data  : '+dataStr);
                 //if(trim(dataStr) <> '')then
                 self.FieldByName(fname).AsString := dataStr;
               end;//for...j...end!!
             self.Post;
             Delta.Next;
           end;//for...i...end!!
         self.ApplyUpdates;
         result := TRUE;
       end;
    ukModify
      :begin
         for i := 0 to Delta.RecordCount-1 do
           begin
             fname   := Delta.Fields[0].FieldName;
             keyStr  := Delta.FieldByName(fname).AsString;
             if(trim(keyStr) <> '')then
               self.FindKey([keyStr])
             else
               begin
                 self.Edit;
                 for j := 0 to Delta.FieldCount-1 do
                   begin
                     fname   := Delta.Fields[j].FieldName;
                     dataStr := Delta.FieldByName(fname).AsString;
                     //debug !! ShowMessage( 'Field : '+fname
                     //debug !!             +#10#13
                     //debug !!             +'Data  : '+dataStr);
                     if(trim(dataStr) <> '')then
                       self.FieldByName(fname).AsString := dataStr;
                   end;//for...j...end!!
                 self.Post;
               end;//else...end!!
             Delta.Next;
           end;//for...i...end!!
         self.ApplyUpdates;
         result := TRUE;
       end;
    ukDelete
      :begin
         for i := 0 to Delta.RecordCount-1 do
           begin
             fname   := Delta.Fields[0].FieldName;
             keyStr  := Delta.FieldByName(fname).AsString;
             if(trim(keyStr) <> '')then
             if(self.FindKey([keyStr]) = TRUE)then
               self.Delete;
             Delta.Next;
           end;//for...i...end!!
         self.ApplyUpdates;
         result := TRUE;
       end;
  end;//case...end!!
end;

//TXDBFileName.
procedure TXDBFileName.Edit;
var FileOpen :TOpenDialog;
    tmpFileDB:TXDBTable;
    str,NameStr:string;
    i,id:integer;
begin
  tmpFileDB := TXDBTable(self.GetComponent(0));
  FileOpen  := TOpenDialog.Create(Nil);
  FileOpen.Filename := GetValue;
  FileOpen.Filter := 'AspFileDB Files (*.XDB)|*.XDB|All Files (*.*)|*.*';
  FileOpen.Options := FileOpen.Options + [ofPathMustExist, ofFileMustExist];
  try
    if(FileOpen.Execute = TRUE)then
    if(trim(FileOpen.Filename) <> '')then
      begin
        //tmpFileDB.SchemaFileName := '';
        tmpFileDB.FFileName := FileOpen.Filename;
        SetValue(FileOpen.Filename);
      end;//if...end!!
  finally
    FileOpen.Free;
    tmpFileDB := nil;
  end;
end;

function TXDBFileName.GetAttributes: TPropertyAttributes;
begin
  result := [paDialog, paRevertable];
end;

end.
